Attribute VB_Name = "ModAPI"
Option Explicit

Public Const MAX_PATH = 255
Public sLastFile  As String


Public Const TOKEN_QUERY As Long = &H8

Public Declare Function GetUserProfileDirectory Lib "userenv.dll" Alias "GetUserProfileDirectoryA" (ByVal hToken As Long, ByVal lpProfileDir As String, lpcchSize As Long) As Boolean
Public Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Public Declare Function GetCurrentProcess Lib "kernel32.dll" () As Long

'for cookies
Public Const OF_SHARE_DENY_NONE As Long = &H40
Public Const OFS_MAXPATHNAME As Long = 128


Public Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Public Declare Function FindFirstFile Lib "kernel32.dll" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindNextFile Lib "kernel32.dll" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindClose Lib "kernel32.dll" (ByVal hFindFile As Long) As Long

Public Declare Function OpenFile Lib "kernel32.dll" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Public Declare Function GetFileTime Lib "kernel32.dll" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Public Declare Function CompareFileTime Lib "kernel32.dll" (lpFileTime1 As FILETIME, lpFileTime2 As FILETIME) As Long


'url cache info
Private Type INTERNET_CACHE_ENTRY_INFO
    dwStructSize As Long
    lpszSourceUrlName As Long
    lpszLocalFileName As Long
    CacheEntryType As Long
    dwUseCount As Long
    dwHitRate As Long
    dwSizeLow As Long
    dwSizeHigh As Long
    LastModifiedTime As FILETIME
    ExpireTime As FILETIME
    LastAccessTime As FILETIME
    LastSyncTime As FILETIME
    lpHeaderInfo As Long
    dwHeaderInfoSize As Long
    lpszFileExtension As Long
    dwReserved As Long
    dwExemptDelta As Long
    'szRestOfData() As Byte
End Type
Public Declare Function FindFirstUrlCacheEntry Lib "wininet.dll" Alias "FindFirstUrlCacheEntryA" (ByVal lpszUrlSearchPattern As String, ByRef lpFirstCacheEntryInfo As INTERNET_CACHE_ENTRY_INFO, ByRef lpdwFirstCacheEntryInfoBufferSize As Long) As Long
Public Declare Function FindNextUrlCacheEntry Lib "wininet.dll" Alias "FindNextUrlCacheEntryA" (ByVal hEnumHandle As Long, ByVal lpNextCacheEntryInfo As Long, ByRef lpdwNextCacheEntryInfoBufferSize As Long) As Long
Public Declare Sub FindCloseUrlCache Lib "wininet.dll" (ByVal hEnumHandle As Long)
Public Declare Function DeleteUrlCacheEntry Lib "wininet.dll" Alias "DeleteUrlCacheEntryA" (ByVal lpszUrlName As String) As Long

'shell execute
Public Const SW_SHOWNORMAL As Long = 1
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long



'program startup
Public Sub main()
 
 frmURLCache.Show
End Sub


'Name:    UserInformation
'Purpose  To get user profile folders location
'Date
'By       Mayur Kotlikar
'Input    No
'Outputs  No

Public Sub UserInformation()
On Error GoTo errhandler
    Dim sTemp      As String   'for storing the
                               'folder Name
    Dim hHandle    As Long     'handle of current token
    Dim ret        As Long
    Dim olstItem   As ListItem
    
    Call OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, hHandle)
    
    'function not successful
    'If ret = 0 Then
     '   Exit Sub
    'End If
    
    'we now have a token handle for the current
    'process and thread,
    'now we can get the user profile directory
    
    sTemp = String$(MAX_PATH, Chr$(0))
    
    GetUserProfileDirectory hHandle, sTemp, MAX_PATH
    
    'assuming the call to be successful
    sTemp = Mid(sTemp, 1, InStr(1, sTemp, Chr$(0)) - 1)
    frmURLCache.lblUserProfileFolder = sTemp
    Set olstItem = frmURLCache.lvwUserInfo.ListItems.Add(, , "User Profile Dir")
    olstItem.SubItems(1) = sTemp
    
    'cookies folder path
    frmURLCache.lblCookiesFolder = sTemp & "\Cookies"
    Set olstItem = frmURLCache.lvwUserInfo.ListItems.Add(, , "Cookies Dir")
    olstItem.SubItems(1) = sTemp & "\Cookies"
    
    'history folder path
    frmURLCache.lblHistoryFolder = sTemp & "\Local Settings\History"
    Set olstItem = frmURLCache.lvwUserInfo.ListItems.Add(, , "History Dir")
    olstItem.SubItems(1) = sTemp & "\Local Settings\History"
    
    'temp inet files
    frmURLCache.lblTempInternetFilesFolder = sTemp & "\Local Settings\Temporary Internet Files"
    Set olstItem = frmURLCache.lvwUserInfo.ListItems.Add(, , "Temp Internet Dir")
    olstItem.SubItems(1) = sTemp & "\Local Settings\Temporary Internet Files"
    
    

Exit Sub
errhandler:
    Debug.Print err.LastDllError & " Normal " & err.Number & " " & err.Description
End Sub


'Name         GetCookiesFiles (Public)
'Purpose
'By           Mayur.Kotlikar
'Date         20/6/2003 1:18:38 PM
'Inputs       None
'Outputs      None
'Description  Fill the lvwFiles list of frmURLCache
'

Public Sub GetCookiesFiles()
On Error GoTo err
    
    Dim sFileName      As String
    Dim wfd            As WIN32_FIND_DATA
    Dim i              As Long
    Dim olstItem       As ListItem
    Dim ret            As Long
    Dim hSearchHandle  As Long
    
    
    'get the first file
    hSearchHandle = FindFirstFile(frmURLCache.lblCookiesFolder & "\*", wfd)
    
    frmURLCache.lvwFiles.ListItems.Clear
    
    i = 1
    
    Do While i <> 0
    
        sFileName = String$(MAX_PATH, Chr$(0))
        sFileName = wfd.cFileName
        sFileName = Left$(sFileName, InStr(sFileName, Chr$(0)) - 1)
                
        'forget . and ..
        If (sFileName <> ".") And (sFileName <> "..") Then
            If Not IsNull(sFileName) Then
                Set olstItem = frmURLCache.lvwFiles.ListItems.Add(, , sFileName)
            End If
        End If
            
        i = FindNextFile(hSearchHandle, wfd)
    Loop



Exit Sub
err:
    Debug.Print err.LastDllError & err.Description
End Sub


'Name     WatchCookies (Public)
'By
'Date
'Purpose  Timer on form will fire this event after every
          '500 ms to get the latest file
          'keep checking the last accessed file
          'if the last accessed file changes notify user
'Inputs   None
'Output   Boolean (Y/N) file change

Public Function WatchCookies() As Boolean
On Error GoTo err
    
    Dim sMostRecent       As String
    Dim sFile             As String
    Dim hFile             As Long
    
    'for file1
    Dim lCreation1        As FILETIME
    Dim lLastAccess1      As FILETIME
    Dim lLastWrite1       As FILETIME
    
    'for file2
    Dim lCreation2        As FILETIME
    Dim lLastAccess2      As FILETIME
    Dim lLastWrite2       As FILETIME
    
    Dim lFileStructure    As OFSTRUCT
    
    sFile = Dir(frmURLCache.lblCookiesFolder & "\*.*")
    
    sMostRecent = sFile
    
    hFile = OpenFile(frmURLCache.lblCookiesFolder & "\" & sFile, lFileStructure, OF_SHARE_DENY_NONE)
    
    Call GetFileTime(hFile, lCreation1, lLastAccess1, lLastWrite1)
    
    'we now have the access time for first file
    'now we willhave to loop in the folder to find the last modified
    
    Do
        sFile = Dir
        hFile = OpenFile(frmURLCache.lblCookiesFolder & "\" & sFile, lFileStructure, OF_SHARE_DENY_NONE)
        
        Call GetFileTime(hFile, lCreation2, lLastAccess2, lLastWrite2)
        
        If CompareFileTime(lLastWrite1, lLastWrite2) = -1 Then
            sMostRecent = sFile
        End If
    Loop Until sFile = ""
    
    If sMostRecent <> "index.dat" Then
        If sLastFile <> vbNullString Then
            If sLastFile <> sMostRecent Then 'file changed
                sLastFile = sMostRecent
                WatchCookies = True
            End If
        Else
            sLastFile = sMostRecent
            WatchCookies = False
        End If
    End If

Exit Function
err:
    Debug.Print err.Description & err.LastDllError
End Function
